#include "includes.h"
#include ".\Monitors\DecoderMonitor.h"
#include ".\Monitors\ShiftRegisterMonitor.h"
//#include ".\Monitors\RomMonitor.h"

#ifdef MTI_SYSTEMC

SC_MODULE(top)
{
    sc_clock clk;
	//RomMonitor monitor;
	DecoderMonitor monitor;
    //ShiftRegisterMonitor monitor;
    
    SC_CTOR(top)
        : clk("clk", 20, 0.5, 0.0, false), monitor("Monitor")
    {
	   monitor.clock(clk);
    }
};

SC_MODULE_EXPORT(top);

#else

int sc_main(int argc, char** argv)
{
	//sc_report_handler::set_actions (SC_ID_VECTOR_CONTAINS_LOGIC_VALUE_, SC_DO_NOTHING);
	//sc_report_handler::set_actions (SC_ID_SC_BV_CANNOT_CONTAIN_X_AND_Z_, SC_DO_NOTHING);
	//_CrtSetDbgFlag(_CrtSetDbgFlag(0)|_CRTDBG_CHECK_ALWAYS_DF);
	sc_clock clock("clock", 20, SC_NS, 0.5, 0, SC_NS, false);
	
	sc_trace_file* tf = sc_create_vcd_trace_file("traces");
	((vcd_trace_file*)tf)->sc_set_vcd_time_unit(-9);

	//RomMonitor monitor("Monitor");
	DecoderMonitor monitor("Monitor");
	//ShiftRegisterMonitor monitor("Monitor");
	monitor.clock(clock);
	monitor.ConnectToVCD(tf);
	_ASSERTE( _CrtCheckMemory( ) );
	sc_start();
	sc_close_vcd_trace_file(tf);

	cout << endl << "Press ENTER to close\n";
	char enter;
    do {
        cin.get(enter);
    } while ( enter != '\n' );
	return 1;
}
#endif // MTI_SYSTEMC
