%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%% 1 Load LDPC-Matrix %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
start_of_programm = tic;
tic;
load PCMregLDPC.mat;
H = PCMregLDPC;
%H = dvbs2ldpc(1/4);
parallelity = 32;
distance = 3;                       % actual pipeline is 1 more as the distance since the SD-Memory is write after read.

cn_number = size(H,1);
sn_number = size(H,2);
virtual_cn_number = 0;
virtual_sn_number = 0;

disp(['1) Loading Matrix = ' num2str(toc) 's']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% 2 Calculations of degrees %%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
% for col = 1:cn_number
%     cn_degrees(col,1) = col;
%     cn_degrees(col,2) = nnz(H(col,:));
% end
cn_degrees = sum(H~=0,2);
cn_degrees = [colon(1,cn_number)', full(cn_degrees)];
disp(['2) Calculating Degrees = ' num2str(toc) 's']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3 Add virtual check nodes and order all check nodes by descending degree%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
%cn_degree_sn_mapping = flipdim(sortrows(cn_degree_sn_mapping, 2),1);
% virtual_cn_number = (parallelity - mod(cn_number, parallelity));
% if virtual_cn_number == parallelity
%     virtual_cn_number = 0;
% end
% cn_degree_sn_mapping = zeros(cn_number + virtual_cn_number, max(cn_degrees(:,2)) + 2);
% cn_degree_sn_mapping(1:cn_number, 1:2) = cn_degrees;
% min_degree = min(cn_degrees(:,2));
% for i = cn_number+1:cn_number+virtual_cn_number
%     cn_degree_sn_mapping(i, 1:2) = [i, min_degree];
% end

cn_degree_sn_mapping = zeros(cn_number , max(cn_degrees(:,2)) + 2);
cn_degree_sn_mapping(1:cn_number, 1:2) = cn_degrees;
min_degree = min(cn_degrees(:,2));
virtual_cn_number = 0;

different_degrees = unique(cn_degrees(:,2));
for i = 1:size(different_degrees,1)
    temp = parallelity - mod(size(find(cn_degrees(:,2) == different_degrees(i)),1), parallelity);
    if temp == parallelity
        temp = 0;
    end
    cn_degree_sn_mapping(cn_number + virtual_cn_number + 1: cn_number + virtual_cn_number + temp, 1) = cn_number + virtual_cn_number + 1: cn_number + virtual_cn_number + temp;
    cn_degree_sn_mapping(cn_number + virtual_cn_number + 1: cn_number + virtual_cn_number + temp, 2) = different_degrees(i);
    virtual_cn_number = virtual_cn_number + temp;
end


for i = 1:cn_number
    cn_degree_sn_mapping(i, 3:2+cn_degree_sn_mapping(i,2)) = find(H(i,:)==1);
end

disp(['3) Order Checknodes after degree and connect to Symbolnodes = ' num2str(toc) 's']); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%% 6 Create access indices for Partition 1  %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
[partition1, checknode_mappings] = SetAccessIndices(cn_degree_sn_mapping, parallelity, distance);
disp(['4) Access indices of symbol nodes (Partition 1) = ' num2str(toc) 's']);


cn_degree_sn_mapping = sortrows(cn_degree_sn_mapping, 1);
cn_edge_sn_index_mapping = zeros(numel(partition1), 5);
first_cn = 1;
for i = 1:cn_number+virtual_cn_number
    cn_degree = checknode_mappings(i,end-2);
    last_cn = first_cn + cn_degree - 1;
    cn_edge_sn_index_mapping(first_cn:last_cn, 1) = i;
    cn_edge_sn_index_mapping(first_cn:last_cn, 3) = cn_degree_sn_mapping(i, 3:2+cn_degree);
    cn_edge_sn_index_mapping(first_cn:last_cn, 4) = checknode_mappings(i, 1:cn_degree);
    first_cn = last_cn + 1;
end

cn_edge_sn_index_mapping(:,2) = 1:numel(partition1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% 7 Add virtual symbol nodes  %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
if parallelity > 1
    cn_edge_sn_index_mapping = sortrows(cn_edge_sn_index_mapping, 3);
    last_sn = sn_number;
    sn = 0;
    indices_of_virtual_sns = find(cn_edge_sn_index_mapping(:,3) == 0);
    virtual_sns = cn_edge_sn_index_mapping(indices_of_virtual_sns, :);
    
    %set zero access indeces to right index
    cns_with_zero_indices = unique(virtual_sns(:,1));
    for i = 1:size(cns_with_zero_indices,1)
        cn = cns_with_zero_indices(i, 1);
        cn_data = cn_edge_sn_index_mapping(cn_edge_sn_index_mapping(:,1) == cn, :);
        first_index = checknode_mappings(cn, end - 1);
        last_index = checknode_mappings(cn, end);
        for j = first_index:last_index
            if isempty(find(cn_data(:, 4) == j, 1))
                cn_data(find(cn_data(:, 4) == 0, 1), 4) = j;
                virtual_sns(find(virtual_sns(:, 4) == 0, 1), 4) = j;
            end
        end
    end
    
    
    virtual_sns = sortrows(virtual_sns, 4);

    first_cn = cn_edge_sn_index_mapping(indices_of_virtual_sns(1),1);
    virtual_sn_number = 0;
    for i = 1:size(indices_of_virtual_sns,1)          %(distance + 1) * (p-1) virtual sns is allways sufficial
        virtual_sns(i, 3) = last_sn + sn + 1;
        sn = mod(sn + 1, (distance + 1) * (parallelity - 1));
        virtual_sn_number = virtual_sn_number + 1;
    end
    if virtual_sn_number > (distance + 1) * (parallelity - 1)
        virtual_sn_number = (distance + 1) * (parallelity - 1);
    end
    virtual_sns = sortrows(virtual_sns, 2);
    cn_edge_sn_index_mapping(indices_of_virtual_sns, :) = virtual_sns;
end
disp(['Adding of virtual symbol nodes = ' num2str(toc) 's']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%% 8 Test Distance of Symbol Node Accesses %%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cn_edge_sn_index_mapping = sortrows(cn_edge_sn_index_mapping, 3);
for i = 1:cn_edge_sn_index_mapping(end, 3)
    sn = cn_edge_sn_index_mapping(cn_edge_sn_index_mapping(:, 3) == i, :);
    for j1 = 1:size(sn,1)
        for j2 = j1 + 1:size(sn,1)
            if abs(sn(j1,4) - sn(j2,4)) <= distance
                disp(['bad']);
            end
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%% 8 Create access indices for Partition 2  %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
cn_edge_sn_index_mapping = sortrows(cn_edge_sn_index_mapping, 3);
cn_edge_sn_index_mapping(:,5) = cn_edge_sn_index_mapping(:,4);
for i = 1:(sn_number + virtual_sn_number)
    edge_indices = find(cn_edge_sn_index_mapping(:,3) == i);
    control_indices = cn_edge_sn_index_mapping(edge_indices, 4);
    [degree, dummy] = size(control_indices);
    permutation = zeros(degree, 3);
    for j = 1:degree
        permutation(j,1) = j;
        permutation(j,2) = control_indices(j,1);
    end
    permutation = sortrows(permutation, 2);
    permutation(2 : degree, 3) = permutation(1 : degree - 1, 2);
    permutation(1, 3) = permutation(degree, 2);
    permutation = sortrows(permutation, 1);
    cn_edge_sn_index_mapping(edge_indices, 5) = permutation(1:degree, 3);
end
cn_edge_sn_index_mapping = sortrows(cn_edge_sn_index_mapping, 1);
disp(['Access indices of symbol nodes (Partition 2) = ' num2str(toc) 's']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 9 Tarable  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
% Prepairing Constraints
cn_edge_sn_index_mapping = sortrows(cn_edge_sn_index_mapping, 5);
constraint1 = zeros(size(partition1));
for i = 1:size(partition1,1)
    edge_indices = find(cn_edge_sn_index_mapping(:, 4) == i);
    constraint1(i,:) = cn_edge_sn_index_mapping(edge_indices, 2)';
end

constraint2 = zeros(size(partition1));
for i = 1:size(partition1,1)
    edge_indices = find(cn_edge_sn_index_mapping(:, 5) == i);
    constraint2(i,:) = cn_edge_sn_index_mapping(edge_indices, 2)';
end
disp(['Creating constraints from both partitions = ' num2str(toc) 's']);

tic;
memory = ArrangeDataTarable(constraint1, constraint2);
disp(['Tarable = ' num2str(toc) 's']);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% 10 Calculating control information %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
sn_access_order = zeros(size(cn_edge_sn_index_mapping,1)/parallelity, parallelity);
init_save_control = zeros(sn_number,2);
permutation_networks = zeros(size(cn_edge_sn_index_mapping,1)/parallelity, 2*parallelity);
sn_control_memory = zeros(size(cn_edge_sn_index_mapping,1)/parallelity, 3*parallelity);
sd_access_memory = zeros(size(cn_edge_sn_index_mapping,1)/parallelity, 3*parallelity);

cn_edge_sn_index_mapping = sortrows(cn_edge_sn_index_mapping,2);
for i = 1:size(cn_edge_sn_index_mapping,1)
    edge = memory(i);
    sn_access_order(i) = cn_edge_sn_index_mapping(edge,3);
end


for i = 1:size(cn_edge_sn_index_mapping,1)/parallelity
    sns = cn_edge_sn_index_mapping(cn_edge_sn_index_mapping(:,4) == i,3);
    for j = 1:parallelity
        if sn_access_order(i, j) ~= 0
            permutation_networks(i, j) = find(sns == sn_access_order(i, j));
        end
    end
    sns = cn_edge_sn_index_mapping(cn_edge_sn_index_mapping(:,5) == i,3:4);
    for j = 1:parallelity
        if sn_access_order(i, j) ~= 0
            [index, sn] = find(sns(:,1) == sn_access_order(i, j));
            [row, col] = find(sn_access_order(sns(index, 2), 1:parallelity) == sns(index, 1));
            permutation_networks(i, j + parallelity) = col;
        end
    end
end
sn_mem_bank = zeros((sn_number + virtual_sn_number),1);
for i = 1:(sn_number + virtual_sn_number)
    [row, col] = find(sn_access_order(:,1:parallelity) == i);
    first_sn = [row, col];
    first_sn = sortrows(first_sn, 1);
    sn_mem_bank(i) = first_sn(1,2);
    sn_control_memory(first_sn(1,1), first_sn(1,2) + parallelity) = 1;
    %first_sn = flipdim(first_sn, 1);
    %sn_control_memory(first_sn(1,1), first_sn(1,2) + 2 * parallelity) = 1;
end
hist_mem_bank = [unique(sn_mem_bank),histc(sn_mem_bank(:,1), unique(sn_mem_bank))];
initial_sd_memory = zeros(max(max(hist_mem_bank)), parallelity);
permuted_sd_memory = zeros(max(max(hist_mem_bank)), parallelity);
for i = 1:parallelity
    sns_in_bank_i = find(sn_mem_bank == i)';
    for j = 1:size(sns_in_bank_i,2)
        permuted_sd_memory(j,i) = sns_in_bank_i(1, j);
        initial_sd_memory(j,i) = sns_in_bank_i(1, j);
    end
end

for i = 1:sn_number
    [row, col] = find(permuted_sd_memory == i);
    init_save_control(i,:) = [col, row];
end

% iteration of control
for i = 1:size(cn_edge_sn_index_mapping,1)/parallelity
    readSN = sn_access_order(i, :);
    [row, col] = find(ismember(permuted_sd_memory, readSN));
    sn_control_memory(i, 1:parallelity) = row;
    new_col = permutation_networks(i, 1+parallelity : 2*parallelity)';
    for j = 1:size(readSN,2)
        sd_access_memory(i, col(j)) = readSN(j);
        permuted_sd_memory(row(new_col(j)), new_col(j)) = readSN(j);
    end
end

sn_control_memory(:, (parallelity + 1) : (2 * parallelity)) = 0;
for i = 1:(sn_number + virtual_sn_number)
    [~, col] = find(permuted_sd_memory(:,1:parallelity) == i);
    [row, ~] = find(sn_access_order == i);
    row = sort(row);
    row = flipdim(row, 1);
    row = row(1);
    if(sn_control_memory(row, col + 2 * parallelity) == 1)
        display('bad');
    end
    sn_control_memory(row, col + 2 * parallelity) = 1;
    
    [~, col] = find(initial_sd_memory(:,1:parallelity) == i);
    [row, ~] = find(sn_access_order == i);
    row = sort(row);
    row = row(1);
    if(sn_control_memory(row, col + parallelity) == 1)
        display('bad');
    end
    sn_control_memory(row, col + parallelity) = 1;
end
sd_access_memory(:, (parallelity + 1) : (3 * parallelity)) = sn_control_memory(:, (parallelity + 1) : (3 * parallelity));
for i = 1:size(cn_edge_sn_index_mapping,1)/parallelity
    sns = cn_edge_sn_index_mapping(cn_edge_sn_index_mapping(:,4) == i,3);
    for j = 1:parallelity
        if sn_access_order(i, j) ~= 0
            permutation_networks(i, find(sns == sn_access_order(i, j))) = j;
        end
    end
    sns = cn_edge_sn_index_mapping(cn_edge_sn_index_mapping(:,5) == i,3:4);
    for j = 1:parallelity
        if sn_access_order(i, j) ~= 0
            [index, sn] = find(sns(:,1) == sn_access_order(i, j));
            [row, col] = find(sn_access_order(sns(index, 2), 1:parallelity) == sns(index, 1));
            permutation_networks(i, col + parallelity) = j;
        end
    end
end
disp(['Calculation of control information = ' num2str(toc) 's']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% 11 Writing Control Information to Memory Files %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic;
hist_cn_degree = flipdim([unique(checknode_mappings(:,end-2)),histc(checknode_mappings(:,end-2),unique(checknode_mappings(:,end-2)))],1);
degree_number = size(hist_cn_degree, 1);
fid = fopen(strcat('..\ControlInformation\RomDS', '.mif'),'w', 'n');
fprintf(fid, '%d\n', degree_number);
fprintf(fid, '%d ', hist_cn_degree(:,1) - 1);
fprintf(fid, '\n');
fprintf(fid, '%d ', hist_cn_degree(:,2) / parallelity);
fprintf(fid, '\n');
fclose(fid);

fid = fopen('..\VHDL\Packages\Cycles.vhd','w', 'n');
fprintf(fid, 'LIBRARY ieee;\n');
fprintf(fid, 'USE ieee.std_logic_1164.all;\n\n');
fprintf(fid, 'PACKAGE cycles IS \n');
fprintf(fid, '\tconstant DEGREE_NUMBER\t\t: integer := %d;\n', degree_number);
fprintf(fid, '\tconstant DEGREE_NUMBER_WIDTH: integer := %d;\n', ceil(log2(degree_number)));
fprintf(fid, '\ttype t_cycles is array (0 to DEGREE_NUMBER - 1) of integer;\n');
fprintf(fid, '\tconstant DEGREES\t\t\t: t_cycles := (');
if degree_number > 1
    for i = 1:(degree_number - 1)
        fprintf(fid, '%d, ', hist_cn_degree(i,1) - 1);
    end
end
fprintf(fid, '%d);\n', hist_cn_degree(degree_number,1) - 1);

fprintf(fid, '\tconstant CYCLES_FIRST\t\t: t_cycles := (');
next_cycle = hist_cn_degree(1,1) * hist_cn_degree(1,2) / parallelity;
if degree_number > 1
    for i = 1:(degree_number - 1)
        fprintf(fid, '%d, ', next_cycle - 2);
    end
    next_cycle = next_cycle + (hist_cn_degree(i+1,1) * hist_cn_degree(i+1,2)  / parallelity);
end
fprintf(fid, '%d);\n', next_cycle - 3);

fprintf(fid, '\tconstant CYCLES_SECOND\t\t: t_cycles := (2, ');
next_cycle = hist_cn_degree(1,1) * hist_cn_degree(1,2) / parallelity;
if degree_number > 2
    for i = 1:(degree_number - 2)
        fprintf(fid, '%d, ', next_cycle + 2);
    end
    next_cycle = next_cycle + (hist_cn_degree(i+1,2) * hist_cn_degree(i+1,2) / parallelity);
end
fprintf(fid, '%d);\n', next_cycle + 2);

fprintf(fid, 'END cycles;\n');
fclose(fid);

init_save_control(:,:) = init_save_control(:,:) - 1;
rom_sn_width = ceil(log2(size(initial_sd_memory,1)));
fid = fopen(strcat('..\ControlInformation\RomInit.mif'),'w', 'n');
for j = 1:size(init_save_control,1)
    fprintf(fid, '%s%s\n', dec2bin(init_save_control(j,1), ceil(log2(parallelity))), dec2bin(init_save_control(j,2), rom_sn_width));
end
size_of_zeroes = power(2, ceil(log2(size(init_save_control,1)))) - size(init_save_control,1);
for j = 1:size_of_zeroes
    fprintf(fid, '%s\n', dec2bin(0, rom_sn_width + ceil(log2(parallelity))));
end
fclose(fid);

rom_address_width = ceil(log2(size(permutation_networks,1)));
sn_control_memory(:,1:parallelity) = sn_control_memory(:,1:parallelity) - 1;
fid = fopen('..\ControlInformation\RomSn.mif','w', 'n');
for j = 1:size(sn_control_memory,1)
    for i = 1:parallelity
        fprintf(fid, '%s%s%s', dec2bin(sn_control_memory(j,i), rom_sn_width), dec2bin(sn_control_memory(j,i+parallelity)), dec2bin(sn_control_memory(j,i+parallelity*2)));
    end
    fprintf(fid, '\n');
end
size_of_zeroes = power(2, rom_address_width) - size(sn_control_memory,1);
for j = 1:size_of_zeroes
    fprintf(fid, '%s\n', dec2bin(0, parallelity * (rom_sn_width + 2)));
end
fclose(fid);

% for i = 1:parallelity
%     fid = fopen(strcat('..\ControlInformation\Rom', strcat('Sn_', int2str(i - 1)), '.mif'),'w', 'n');
%     for j = 1:size(sn_control_memory,1)
%         fprintf(fid, '%s%s%s\n', dec2bin(sn_control_memory(j,i), rom_sn_width), dec2bin(sn_control_memory(j,i+parallelity)), dec2bin(sn_control_memory(j,i+parallelity*2)));
%     end
%     fclose(fid);
% end

permutation_networks(:,:) = permutation_networks(:,:) - 1;
fid = fopen(strcat('..\ControlInformation\RomPi0', '.mif'),'w', 'n');
for i = 1:size(sn_control_memory,1)
    fprintf(fid, '%s\n', sprintf(dec2bin(permutation_networks(i, 1 : parallelity))'));
end
size_of_zeroes = power(2, rom_address_width) - size(sn_control_memory,1);
for j = 1:size_of_zeroes
    fprintf(fid, '%s\n', dec2bin(0, ceil(log2(parallelity))*parallelity));
end
fclose(fid);
fid = fopen(strcat('..\ControlInformation\RomPi2', '.mif'),'w', 'n');
for i = 1:size(sn_control_memory,1)
    fprintf(fid, '%s\n', sprintf(dec2bin(permutation_networks(i, parallelity + 1 : 2 * parallelity))'));
end
size_of_zeroes = power(2, rom_address_width) - size(sn_control_memory,1);
for j = 1:size_of_zeroes
    fprintf(fid, '%s\n', dec2bin(0, ceil(log2(parallelity))*parallelity));
end
fclose(fid);

fid = fopen('..\ControlInformation\widths.h','w', 'n');
fprintf(fid, '#ifndef WIDTHS_H\n');
fprintf(fid, '#define WIDTHS_H\n');
fprintf(fid, '#define ROM_SIZE %d\n', size(permutation_networks,1));
fprintf(fid, '#define ROM_ADDRESS_WIDTH %d\n', rom_address_width);
fprintf(fid, '#define ROM_PERMUTATION_WIDTH %d\n', ceil(log2(parallelity))*parallelity);
fprintf(fid, '#define ROM_SN_WIDTH %d\n', ceil(log2(size(initial_sd_memory,1)))+2);
fprintf(fid, '#define ROM_INITILIZATION_ADDRESS_WIDTH %d\n', ceil(log2(sn_number)));
fprintf(fid, '#define PARALLELISM %d\n', parallelity);
fprintf(fid, '#define PARALLELISM_WIDTH %d\n', ceil(log2(parallelity)));
fprintf(fid, '#define SN_NUMBER %d\n', sn_number);
fprintf(fid, '#define MAX_DEGREE %d\n', hist_cn_degree(1,1));
fprintf(fid, '#define DEGREE_WIDTH %d\n', ceil(log2(hist_cn_degree(1,1))));
fprintf(fid, '#define RAM_CN_ADDRESS_WIDTH %d\n', ceil(log2((cn_number + virtual_cn_number)/parallelity)));

fprintf(fid, '#define CN_PER_FU %d\n', (cn_number + virtual_cn_number)/parallelity);
fprintf(fid, '#define SN_PER_FU %d\n', size(initial_sd_memory,1));
fprintf(fid, '#define RAM_SN_ADDRESS_WIDTH %d\n', ceil(log2(size(initial_sd_memory,1))));
fprintf(fid, '#endif //WIDTHS_H \n');
fclose(fid);

fid = fopen('..\VHDL\Packages\Widths.vhd','w', 'n');
fprintf(fid, 'LIBRARY ieee;\n');
fprintf(fid, 'USE ieee.std_logic_1164.all;\n\n');
fprintf(fid, 'PACKAGE widths IS \n');
fprintf(fid, '\tconstant ROM_SIZE : integer := %d;\n', size(permutation_networks,1));
fprintf(fid, '\tconstant ROM_ADDRESS_WIDTH  : integer := %d;\n', rom_address_width);
fprintf(fid, '\tconstant ROM_PERMUTATION_WIDTH  : integer := %d;\n', ceil(log2(parallelity))*parallelity);
fprintf(fid, '\tconstant ROM_SN_WIDTH  : integer := %d;\n', ceil(log2(size(initial_sd_memory,1)))+2);
fprintf(fid, '\tconstant ROM_INITILIZATION_ADDRESS_WIDTH  : integer := %d;\n', ceil(log2(sn_number)));
fprintf(fid, '\tconstant PARALLELISM  : integer := %d;\n', parallelity);
fprintf(fid, '\tconstant PARALLELISM_WIDTH  : integer := %d;\n', ceil(log2(parallelity)));
fprintf(fid, '\tconstant SN_NUMBER  : integer := %d;\n', sn_number);
fprintf(fid, '\tconstant MAX_DEGREE  : integer := %d;\n', hist_cn_degree(1,1));
fprintf(fid, '\tconstant DEGREE_WIDTH  : integer := %d;\n', ceil(log2(hist_cn_degree(1,1))));
fprintf(fid, '\tconstant RAM_CN_ADDRESS_WIDTH  : integer := %d;\n', ceil(log2((cn_number + virtual_cn_number)/parallelity)));

fprintf(fid, '\tconstant CN_PER_FU  : integer := %d;\n', (cn_number + virtual_cn_number)/parallelity);
fprintf(fid, '\tconstant SN_PER_FU  : integer := %d;\n', size(initial_sd_memory,1));
fprintf(fid, '\tconstant RAM_SN_ADDRESS_WIDTH : integer := %d;\n', ceil(log2(size(initial_sd_memory,1))));
fprintf(fid, 'END widths;\n');
fclose(fid);

disp(['Writing control information to file = ' num2str(toc) 's']);
disp(['Total time = ' num2str(toc(start_of_programm)) 's']);
