function [partition1, checknodes_indices] = SetAccessIndices(cn_degree_sn_mapping, p, dist)
global index_sns_mapping;
global distance;
global matrix;
global calc_matrix;
global bank;
global checknodes_indices;
global parallelism;

parallelism = p;
bank = 1;
distance = dist;
calc_matrix = [cn_degree_sn_mapping(:, 3:end), cn_degree_sn_mapping(:, 1:2)];
matrix = calc_matrix;
matrix = sortrows(matrix, size(matrix,2)-1);
calc_matrix = flipdim(sortrows(calc_matrix, size(calc_matrix,2)), 1);
%calc_matrix = sortrows(calc_matrix, size(calc_matrix,2));
[cn_number, max_degree] = size(calc_matrix);
max_degree = max_degree - 2;
%this calc_matrix will be expanded on demand / at least (cn_number/parallelity)
%cycles are needed
last_last_index = ceil(nnz(calc_matrix(:, 1:max_degree)) / parallelism);
index_sns_mapping = zeros(last_last_index, parallelism);
checknodes_indices = zeros(cn_number, max_degree + 4);    % indices + bank + degree + first_index + last_index

first_access_index = 1;

matrix_index = 1;
cn_index = 1;
failed_cns_before = 0;
while(1) % iteration through subblocks
    cn = calc_matrix(matrix_index, end - 1);
    last_access_index = first_access_index - 1 + matrix(cn, end);
    [m,v] = max( cumsum(index_sns_mapping~=0) );
    v(m==0) = 0;
    v = max(v);
    if last_access_index < v % between degrees
        last_access_index = v;
    end
    [valid, indices] = CalculateIndices(cn, first_access_index, last_access_index);
    if valid == 1
        temp = first_access_index;
        first_access_index = IndexCn(first_access_index, last_access_index, indices, cn);
        calc_matrix(matrix_index, 1 : end-1) = 0;
        if temp ~= first_access_index % new block
            calc_matrix = calc_matrix(any(calc_matrix(:,1:end-1),2), :);
            if size(calc_matrix, 1) == 0
                break; % done
            end
            matrix_index = 1;
        end
        if size(calc_matrix, 1) == 1
            break; % done
        end
    end
    
    % go to the next check node
    if matrix_index == size(calc_matrix, 1) || calc_matrix(matrix_index, end) ~= calc_matrix(matrix_index + 1, end)
        if failed_cns_before == nnz(calc_matrix(1:matrix_index, end-1)) && failed_cns_before ~= 0
            first_access_index = Permute(first_access_index, calc_matrix(1:failed_cns_before,:));
            matrix_index = 1;
            calc_matrix(1:failed_cns_before, 1 : end - 1) = 0;
            failed_cns_before = 0;
            calc_matrix = calc_matrix(any(calc_matrix(:,1:end-1),2), :);
            if size(calc_matrix, 1) == 0
                break; % done
            end
            continue;
        end
        failed_cns_before = nnz(calc_matrix(1:matrix_index, end-1));
        calc_matrix = calc_matrix(any(calc_matrix(:,1:end-1),2), :);
        if size(calc_matrix, 1) == 0
            break; % done
        end
        matrix_index = 1;
    else
        matrix_index = matrix_index + 1;
    end
end
partition1 = index_sns_mapping;

end

function first_access_index = Permute(first_access_index, failed_cns)
    global matrix;
    global index_sns_mapping;
    global checknodes_indices;
    cns_with_same_degree = matrix(matrix(:,end) == failed_cns(1,end), size(matrix,2)-1);
    failed_cn_index = 1;
    degree = failed_cns(failed_cn_index, end);
    while(1)
        last_access_index = first_access_index - 1 + degree;
        for i = 1:size(cns_with_same_degree,1)
            candidate_cn = cns_with_same_degree(i);
            [c_valid, c_indices] = CalculateIndices(candidate_cn, first_access_index, last_access_index);
            if c_valid == 1 % candidate found
                %save candidates data and clear it in indes_sns_mapping
                candidates_first_access_index = checknodes_indices(candidate_cn, end - 1);
                candidates_bank = checknodes_indices(candidate_cn, end - 3);
                if candidates_bank == 0
                    continue;
                end
                candidates_indices = index_sns_mapping(checknodes_indices(candidate_cn, end - 1):checknodes_indices(candidate_cn, end), candidates_bank);
                index_sns_mapping(checknodes_indices(candidate_cn, end - 1):checknodes_indices(candidate_cn, end), candidates_bank) = 0;
                
                % try failed_cn on the position of candidate
                failed_cn_to_swap = failed_cns(failed_cn_index, end - 1);
                [valid, indices] = CalculateIndices(failed_cn_to_swap, candidates_first_access_index, candidates_first_access_index + degree - 1);
                if valid == 1 % switch
                    %failed -> candidates place
                    index_sns_mapping(indices, candidates_bank) = matrix(failed_cn_to_swap, 1 : matrix(failed_cn_to_swap, end));
                    % test candidate again with placed failed cn
                    [c_valid, c_indices] = CalculateIndices(candidate_cn, first_access_index, last_access_index);
                    if c_valid == 1 % permutation possible
                        %actualize date of failed cn
                        checknodes_indices(failed_cn_to_swap, 1:matrix(failed_cn_to_swap, end)) = indices';
                        checknodes_indices(failed_cn_to_swap, end-3:end) = [candidates_bank, matrix(failed_cn_to_swap, end), candidates_first_access_index, candidates_first_access_index + matrix(failed_cn_to_swap, end) - 1];
                        
                        %candidate -> next
                        first_access_index = IndexCn(first_access_index, last_access_index, c_indices, candidate_cn);

                        % 
                        failed_cns(failed_cn_index, 1 : end - 1) = 0;
                        failed_cn_index = failed_cn_index + 1;
                        break;
                    else % restore indices of candidate
                        index_sns_mapping(candidates_first_access_index :checknodes_indices(candidate_cn, end), candidates_bank) = candidates_indices;
                    end
                else % restore indices of candidate
                    index_sns_mapping(candidates_first_access_index:checknodes_indices(candidate_cn, end), candidates_bank) = candidates_indices;
                end
            end
            if i == size(cns_with_same_degree,1) % failed
                first_access_index = IndexCn(first_access_index, last_access_index, c_indices, 0);
            end
        end
        if nnz(failed_cns(:,end-1)) == 0
            break; % all permuted
        end
    end
end

function first_access_index = IndexCn(first_access_index, last_access_index, indices, cn)
    global matrix;
    global index_sns_mapping;
    global checknodes_indices;
    global bank;
    global parallelism;
    new_degree = last_access_index - first_access_index + 1;
    if cn ~= 0
        index_sns_mapping(indices, bank) = matrix(cn, 1 : matrix(cn, end));
        checknodes_indices(cn, 1:matrix(cn, end)) = indices';
        %matrix(cn, end) = new_degree;   % set new degree 
        checknodes_indices(cn, end-3:end) = [bank, new_degree, first_access_index, last_access_index];
    end
    
    if bank == parallelism || cn == 0% block done
        bank = 1;
        first_access_index = last_access_index + 1;
    else
        bank = bank + 1;
    end
end

% This function calculates access indices for symbol nodes of given
% checknode if possible
function [valid, indices] = CalculateIndices(cn, first_access_index, last_access_index)
    global matrix;
    global index_sns_mapping;
    global distance;
    indices = zeros(matrix(cn, end), 1);
    valid = 1;
    i = 1;

    while(1)
        %Validation
        sn_index = matrix(cn, i);
        sn_set = 0;
        first_iteration_index = first_access_index;
        if indices(i, 1) ~= 0
            first_iteration_index = indices(i, 1) + 1;
            indices(i, 1) = 0;
        end
        
        for j = first_iteration_index : last_access_index
            if ~isempty(find(indices == j, 1))
                continue;
            end
            
            % Validation
            min_index = j - distance;
            if min_index < 1
                min_index = 1;
            end
            max_index = j + distance;
            if max_index > size(index_sns_mapping, 1);
                max_index = size(index_sns_mapping, 1);
            end
            consecutive_sn = find(index_sns_mapping(min_index : max_index, :) == sn_index, 1);

            if isempty(consecutive_sn) || sn_index == 0
                indices(i, 1) = j;
                sn_set = 1;
                break;
            else
                
            end
        end
        if sn_set == 0
            i = i - 1;
            if i > 0
                continue;
            else
                valid = 0;
                break;
            end
        else
            if i == matrix(cn, end)
                break;
            else
                i = i + 1;
            end
        end
    end
end




function [partition1, checknodes_order] = SetAccessIndices_bak(cn_degree_sn_mapping, parallelism, dist)
global calc_matrix;
global index_sns_mapping;
global distance;
distance = dist;
calc_matrix = [cn_degree_sn_mapping(:, 3:end), cn_degree_sn_mapping(:, 1:2)];
[cn_number, max_degree] = size(calc_matrix);
max_degree = max_degree - 2;
%this calc_matrix will be expanded on demand / at least (cn_number/parallelity)
%cycles are needed
last_last_index = ceil(nnz(calc_matrix(:, 1:max_degree)) / parallelism);
index_sns_mapping = zeros(last_last_index, parallelism);
checknodes_order = zeros(cn_number / parallelism, parallelism);

first_access_index = 1;
last_access_index = calc_matrix(1, end);
matrix_index = 1;
cn_index = 1;
failed_matrix_indices = zeros(1, cn_number);
failed_matrix_index = 0;
end_of_degree_reached = 0;
first_failed_matrix_index = 0;
failed_cns_before = 0;
first_index_of_next_degree = 0;
while(1) % iteration through subblocks
    [valid, indices] = CalculateIndices(matrix_index, first_access_index, last_access_index);
    if valid == 1
        bank = mod(cn_index, parallelism);
        if bank == 0 % block done
            bank = parallelism;
            first_access_index = last_access_index;
            last_access_index = first_access_index + calc_matrix(matrix_index + 1, end);
            first_access_index = first_access_index + 1;
        end
        index_sns_mapping(indices, bank) = calc_matrix(matrix_index, 1 : calc_matrix(matrix_index, end));
        checknodes_order(ceil(cn_index/parallelism), bank) = calc_matrix(matrix_index, end - 1);
        calc_matrix(matrix_index, 1 : end - 1) = 0;
        cn_index = cn_index + 1;
        if end_of_degree_reached == 1
            failed_matrix_indices(1, failed_matrix_indices == matrix_index) = 0;
            failed_matrix_index = failed_matrix_index - 1;
        end;
    else
        if end_of_degree_reached ~= 1
            failed_matrix_index = failed_matrix_index + 1;
            failed_matrix_indices(1, failed_matrix_index) = matrix_index;
        end;
    end
    
    % go to the next subblock
    if matrix_index == cn_number
        end_of_degree_reached = 1;
        matrix_index = failed_matrix_indices(find(failed_matrix_indices(1, :) > 0, 1));
        first_failed_matrix_index = matrix_index;
        failed_cns_before = nnz(failed_matrix_indices);
        first_index_of_next_degree = 0;
        continue;
    else
        if end_of_degree_reached == 0
            if calc_matrix(matrix_index, end) ~= calc_matrix(matrix_index + 1, end)
                end_of_degree_reached = 1;
                first_index_of_next_degree = matrix_index + 1;
                matrix_index = failed_matrix_indices(find(failed_matrix_indices(1, :) > 0, 1));
                first_failed_matrix_index = matrix_index;
                failed_cns_before = nnz(failed_matrix_indices);
            else
                matrix_index = matrix_index + 1;
            end
        else % iterate through failed_matrix_indices
            matrix_index = failed_matrix_indices(find(failed_matrix_indices(1, :) > first_failed_matrix_index,1));
            first_failed_matrix_index = matrix_index + 1;
            if isempty(matrix_index)
                if failed_cns_before == nnz(failed_matrix_indices)
                    if first_index_of_next_degree == 0
                        break; % failed calc_matrix indices left
                    end
                    matrix_index = first_index_of_next_degree;
                    end_of_degree_reached = 0;
                    continue;
                end;
                failed_cns_before = nnz(failed_matrix_indices);
                first_failed_matrix_index = 1;
                matrix_index = failed_matrix_indices(find(failed_matrix_indices(1, :) > first_failed_matrix_index,1));
                if isempty(matrix_index)
                    if first_index_of_next_degree == 0
                        break; % success
                    end
                    matrix_index = first_index_of_next_degree;
                    end_of_degree_reached = 0;
                    % set new degree to new block
                    cn_index = cn_index + (parallelism - floor(mod(cn_index, parallelism)) + 1);
                    first_access_index = last_access_index;
                    last_access_index = first_access_index + calc_matrix(first_index_of_next_degree, end);
                    first_access_index = first_access_index + 1;
                    continue;
                end
            end
        end
    end
end
partition1 = index_sns_mapping;
end